Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XXYYZZ\>\"", RowBox[{"(*", "Change XXYYZZ to the UID of your Silent Stepper Brick", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"ss", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickSilentStepper\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"ss", "@", RowBox[{"SetMotorCurrent", "[", "800", "]"}], RowBox[{"(*", "800mA", "*)"}]}],
   RowBox[{"ss", "@", RowBox[{"SetStepConfiguration", "[", RowBox[{"BrickSilentStepper`STEPURESOLUTIONU8", ",", RowBox[{"\[IndentingNewLine]", "True"}]}], "]"}], RowBox[{"(*", "1/8 steps (interpolated)", "*)"}]}],
   RowBox[{"ss", "@", RowBox[{"SetMaxVelocity", "[", "2000", "]"}], RowBox[{"(*", "Velocity 2000 steps/s", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Slow acceleration (500 steps/s^2),", "*)"}],
   RowBox[{"(*", "Fast deacceleration (5000 steps/s^2)", "*)"}],
   RowBox[{"ss", "@", RowBox[{"SetSpeedRamping", "[", RowBox[{"500", ",", "5000"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"ss", "@", RowBox[{"Enable", "[", "]"}], RowBox[{"(*", "Enable motor power", "*)"}]}],
   RowBox[{"ss", "@", RowBox[{"SetSteps", "[", "60000", "]"}], RowBox[{"(*", "Drive 60000 steps forward", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"Input", "[", "\"\<Click OK to exit\>\"", "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Clean up", "*)"}],
   RowBox[{"ss", "@", RowBox[{"Disable", "[", "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "ss", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
