Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XYZ\>\"", RowBox[{"(*", "Change XYZ to the UID of your CAN Bricklet", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"can", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickletCAN\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Configure transceiver for loopback mode", "*)"}],
   RowBox[{"can", "@", RowBox[{"SetConfiguration", "[", RowBox[{"BrickletCAN`BAUDURATEU1000KBPS", ",", "BrickletCAN`TRANSCEIVERUMODEULOOPBACK", ",", "0"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Callback function for frame read callback", "*)"}],
   RowBox[{RowBox[{"FrameReadCB", "[", RowBox[{"sender_", ",", "frameType_", ",", "identifier_", ",", "data_", ",", "length_"}], "]"}], ":=", "\[IndentingNewLine]", RowBox[{"Module", "[", RowBox[{RowBox[{"{", "}"}], ",", RowBox[{"\[IndentingNewLine]", RowBox[{"Print", "[", RowBox[{"\"\<Frame Type: \>\"", "<>", RowBox[{"ToString", "[", RowBox[{"N", "[", "frameType", "]"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"Print", "[", RowBox[{"\"\<Identifier: \>\"", "<>", RowBox[{"ToString", "[", RowBox[{"N", "[", "identifier", "]"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"Print", "[", RowBox[{"\"\<Data (Length: \>\"", "<>", RowBox[{"ToString", "[", RowBox[{"N", "[", "length", "]"}], "]"}], "<>", "\"\<): \>\"", "<>", RowBox[{"ToString", "[", "data", "]"}]}], "]"}], "\[IndentingNewLine]"}]}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"AddEventHandler", "[", RowBox[{RowBox[{"can", "@", "FrameReadCallback"}], ",", "FrameReadCB"}], "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Enable frame read callback", "*)"}],
   RowBox[{"can", "@", RowBox[{"EnableFrameReadCallback", "[", "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Write standard data frame with identifier 1742 and 3 bytes of data", "*)"}],
   RowBox[{"data", "=", RowBox[{"{", RowBox[{"42", ",", "23", ",", "17", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}],
   RowBox[{"can", "@", RowBox[{"WriteFrame", "[", RowBox[{"BrickletCAN`FRAMEUTYPEUSTANDARDUDATA", ",", "1742", ",", "data", ",", "3"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"Input", "[", "\"\<Click OK to exit\>\"", "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Clean up", "*)"}],
   RowBox[{"can", "@", RowBox[{"DisableFrameReadCallback", "[", "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "can", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
