Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XYZ\>\"", RowBox[{"(*", "Change XYZ to the UID of your GPS Bricklet", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"gps", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickletGPS\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"latitude", "=", "0", ";", "ns", "=", "0", ";", "longitude", "=", "0", ";", "ew", "=", "0", ";", "pdop", "=", "0", ";", "hdop", "=", "0", ";", "vdop", "=", "0", ";", "epe", "=", "0"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Get current coordinates", "*)"}],
   RowBox[{"gps", "@", RowBox[{"GetCoordinates", "[", RowBox[{"latitude", ",", "ns", ",", "longitude", ",", "ew", ",", "pdop", ",", "hdop", ",", "vdop", ",", "epe"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"Print", "[", RowBox[{"\"\<Latitude: \>\"", "<>", RowBox[{"ToString", "[", RowBox[{"N", "[", RowBox[{"Quantity", "[", RowBox[{"latitude", ",", "\"\<\.b0/1000000\>\""}], "]"}], "]"}], "]"}]}], "]"}],
   RowBox[{"Print", "[", RowBox[{"\"\<N/S: \>\"", "<>", RowBox[{"FromCharacterCode", "[", "ns", "]"}]}], "]"}],
   RowBox[{"Print", "[", RowBox[{"\"\<Longitude: \>\"", "<>", RowBox[{"ToString", "[", RowBox[{"N", "[", RowBox[{"Quantity", "[", RowBox[{"longitude", ",", "\"\<\.b0/1000000\>\""}], "]"}], "]"}], "]"}]}], "]"}],
   RowBox[{"Print", "[", RowBox[{"\"\<E/W: \>\"", "<>", RowBox[{"FromCharacterCode", "[", "ew", "]"}]}], "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Clean up", "*)"}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "gps", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
