Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XYZ\>\"", RowBox[{"(*", "Change XYZ to the UID of your Humidity Bricklet", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"h", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickletHumidity\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Get threshold callbacks with a debounce time of 10 seconds (10000ms)", "*)"}],
   RowBox[{"h", "@", RowBox[{"SetDebouncePeriod", "[", "10000", "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Callback function for humidity reached callback", "*)"}],
   RowBox[{RowBox[{"HumidityReachedCB", "[", RowBox[{"sender_", ",", "humidity_"}], "]"}], ":=", "\[IndentingNewLine]", RowBox[{"Module", "[", RowBox[{RowBox[{"{", "}"}], ",", RowBox[{"\[IndentingNewLine]", RowBox[{"Print", "[", RowBox[{"\"\<Humidity: \>\"", "<>", RowBox[{"ToString", "[", RowBox[{"N", "[", RowBox[{"Quantity", "[", RowBox[{"humidity", ",", "\"\<%RH/10\>\""}], "]"}], "]"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"Print", "[", "\"\<Recommended humiditiy for human comfort is 30 to 60 %RH.\>\"", "]"}], "\[IndentingNewLine]"}]}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"AddEventHandler", "[", RowBox[{RowBox[{"h", "@", "HumidityReachedCallback"}], ",", "HumidityReachedCB"}], "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Configure threshold for humidity ", "\"\<outside of 30 to 60 %RH\>\"", "", "*)"}],
   RowBox[{"option", "=", "Tinkerforge`BrickletHumidity`THRESHOLDUOPTIONUOUTSIDE"}],
   RowBox[{"h", "@", RowBox[{"SetHumidityCallbackThreshold", "[", RowBox[{"option", ",", RowBox[{"30", "*", "10"}], ",", RowBox[{"60", "*", "10"}]}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"Input", "[", "\"\<Click OK to exit\>\"", "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Clean up", "*)"}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "h", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
