Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XYZ\>\"", RowBox[{"(*", "Change XYZ to the UID of your Moisture Bricklet", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"m", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickletMoisture\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Callback function for moisture value callback", "*)"}],
   RowBox[{RowBox[{"MoistureCB", "[", RowBox[{"sender_", ",", "moisture_"}], "]"}], ":=", "\[IndentingNewLine]", RowBox[{"Print", "[", RowBox[{"\"\<Moisture Value: \>\"", "<>", RowBox[{"ToString", "[", "moisture", "]"}]}], "]"}]}],
   RowBox[{"AddEventHandler", "[", RowBox[{RowBox[{"m", "@", "MoistureCallback"}], ",", "MoistureCB"}], "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Set period for moisture value callback to 1s (1000ms)", "*)"}],
   RowBox[{"(*", "Note: The moisture value callback is only called every second", "*)"}],
   RowBox[{"(*", "if the moisture value has changed since the last call!", "*)"}],
   RowBox[{"m", "@", RowBox[{"SetMoistureCallbackPeriod", "[", "1000", "]"}]}],
   RowBox[{"
"}],
   RowBox[{"Input", "[", "\"\<Click OK to exit\>\"", "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Clean up", "*)"}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "m", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
